

#include <stdio.h>
#include <sched.h>
#include <stdlib.h>
#include <semaphore.h>
#include <errno.h>


/*  Number of resources
*/
#define NUMBER_DISK 3
#define NUMBER_BUFFER 3


/* Semaphores to manage resources
*/
sem_t disk_sem;
sem_t buffer_sem;




void allocate(int id, int disk_request, int buffer_request)
{
 int i;
 int status;

 for(i=0;i<disk_request;i++) {
   status=sem_wait(&disk_sem);
   if(status!=0)
	returncode("sem_wait disk_sem",status);
 }

 for(i=0;i<buffer_request;i++) {
   status=sem_wait(&buffer_sem);
   if(status!=0)
	returncode("sem_wait buffer_sem",status);
 }

 printf("Thread number %d has allocated the resources\n",id);

}



void release(int id, int disk_request, int buffer_request)
{
 int i;
 int status;

 for(i=0;i<disk_request;i++) {
   status=sem_post(&disk_sem);
   if(status!=0)
	returncode("sem_post disk_sem",status);
 }

 for(i=0;i<buffer_request;i++) {
   status=sem_post(&buffer_sem);
   if(status!=0)
	returncode("sem_post buffer_sem",status);
 }

 printf("Thread number %d has released the resources\n",id);

}





void init_monitor(void)
{
 int status;

 status=sem_init(&disk_sem,0,NUMBER_DISK);
 if(status!=0)
	returncode("sem_init disk_sem",status);

 status=sem_init(&buffer_sem,0,NUMBER_BUFFER);
 if(status!=0)
	returncode("sem_init buffer_sem",status);
 
}

